package com.example.sitodo.functional;

import com.codeborne.selenide.ElementsCollection;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Tag;
import org.junit.jupiter.api.Test;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

import java.util.List;

import static com.codeborne.selenide.Selenide.*;
import static org.junit.jupiter.api.Assertions.assertEquals;

@DisplayName("User Story 4: Bulk Update Todo Item")
@Tag("e2e")
class BulkUpdateToDoItemTest extends BaseFunctionalTest {

    @Test
    @DisplayName("User can create multiple to do items and mark it as finished")
    void addMultipleToDoItems_thenFinishIt() {
        open("/");

        // Create new items and check whether it was successfully saved
        postNewTodoItem("Buy milk");
        checkItemsInList(List.of("Buy milk"));
        postNewTodoItem("Buy cheese");
        checkItemsInList(List.of("Buy milk", "Buy cheese"));

        // Click update button
        WebElement updateButton = $(By.id("update-button"));
        updateButton.click();
        try{
            Thread.sleep(300);
        }
        catch(InterruptedException ie){

        }

        //Click all checkboxes
        List<WebElement> checkBoxes = webdriver().object().findElements(By.xpath("//input[@id='todo-checkbox']"));
        for (WebElement cb:checkBoxes){
            cb.click();
        }

        //Click button 'Mark as Finished'
        WebElement finishedButton = $(By.id("mark-as-finished"));
        finishedButton.click();

        // Check again the items, now marked as finished
        checkItemsInList(List.of("Buy milk", "Buy cheese"));
        ElementsCollection rows = $(By.tagName("tbody")).findAll(By.tagName("tr"));

        List<WebElement> column1 = rows.get(0).findElements(By.tagName("td"));
        String title1 = column1.get(1).getText();
        String status1 = column1.get(2).getText();

        List<WebElement> column2 = rows.get(1).findElements(By.tagName("td"));
        String title2 = column2.get(1).getText();
        String status2 = column2.get(2).getText();

        assertEquals("Buy milk", title1);
        assertEquals("Finished", status1);

        assertEquals("Buy cheese", title2);
        assertEquals("Finished", status2);
    }
}
